namespace Unibas.Aci.Persistenza {

using System.Data;
using Unibas.Aci.Modello;

public class DAOAutomobile {

    public static Automobile DoSelectTarga(string targa) {
        DataSource dataSource = DataSource.GetInstance();
        IDbConnection connection = null;
        IDbCommand command = null;
        IDataReader dataReader = null;
        Automobile automobile = null;
        try {
            connection = dataSource.GetConnection();
            command = connection.CreateCommand();
            string query = "select * from automobili where targa = '" + targa + "'";
            Unibas.Utilita.Logger.Log("DAOProprietario", "DoSelectCodiceFiscale", query);
            command.CommandText = query;
            dataReader = command.ExecuteReader();
            if (dataReader.Read()) {
                automobile = new Automobile();
                automobile.Targa = (string)dataReader["targa"];
                automobile.Modello = (string)dataReader["modello"];
                automobile.Cilindrata = (int)dataReader["cilindrata"];
                automobile.CodiceFiscaleProprietario = (string)dataReader["proprietario"];
            }
        } catch (System.Exception sqle) {
            throw new DAOException("DoInsert: " + sqle);
        } finally {
            dataSource.Close(connection);
        }
        return automobile;
    }

    public static void DoInsert(Automobile automobile) {
        DataSource dataSource = DataSource.GetInstance();
        IDbConnection connection = null;
        IDbCommand command = null;
        try {
            connection = dataSource.GetConnection();
            command = connection.CreateCommand();
            string query =
                    "insert into automobili values ('" + automobile.Targa + "', " +
                    "'" + automobile.Modello + "', " +
                    "" + automobile.Cilindrata + ", " +
                    "'" + automobile.Proprietario.CodiceFiscale + "')";
            Unibas.Utilita.Logger.Log("DAOAutomobile", "DoInsert", query);
            command.CommandText = query;
            command.ExecuteNonQuery();
        } catch (System.Exception sqle) {
            throw new DAOException("DoInsert: " + sqle);
        } finally {
            dataSource.Close(connection);
        }
    }
    
    public static void DoDelete(Automobile automobile) {
        DataSource dataSource = DataSource.GetInstance();
        IDbConnection connection = null;
        IDbCommand command = null;
        try {
            connection = dataSource.GetConnection();
            command = connection.CreateCommand();
            string query = "delete from automobili " +
                    "where targa = '" + automobile.Targa + "'";
            Unibas.Utilita.Logger.Log("DAOAutomobile", "DoDelete", query);
            command.CommandText = query;
            command.ExecuteNonQuery();
        } catch (System.Exception sqle) {
            throw new DAOException("DoDelete: " + sqle);
        } finally {
            dataSource.Close(connection);
        }
    }

    public static void DoUpdate(Automobile automobile) {
        DataSource dataSource = DataSource.GetInstance();
        IDbConnection connection = null;
        IDbCommand command = null;
        try {
            connection = dataSource.GetConnection();
            command = connection.CreateCommand();
            string query =
                    "update automobili set " +
                    "modello = '" + automobile.Modello + "'," +
                    "cilindrata = " + automobile.Cilindrata + "," +
                    "proprietario = '" + automobile.Proprietario.CodiceFiscale + "'" +
                    "where targa = '" + automobile.Targa + "'";
            Unibas.Utilita.Logger.Log("DAOAutomobile", "DoUpdate", query);
            command.CommandText = query;
            command.ExecuteNonQuery();
        } catch (System.Exception sqle) {
            throw new DAOException("DoUpdate: " + sqle);
        } finally {
            dataSource.Close(connection);
        }
    }
    
    public static void CaricaProprietario(Automobile automobile) {
        Proprietario proprietario = DAOProprietario.DoSelectCodiceFiscale(automobile.CodiceFiscaleProprietario);
        automobile.Proprietario = proprietario;
    }

}

}
