namespace Unibas.Aci.Persistenza {

using System.Data;

public class DataSource {
	
    private static DataSource singleton = new DataSource();
   
    public static DataSource GetInstance() {
        return singleton;
    }
    
    private DataSource() {}

    // per utilizzare SQLServer
    private string dataSource = "localhost";
    private string dataBase = "acibase";
    private string userId = "msdeuser";
    private string password = "msdeuser";
    
    public IDbConnection GetConnection() {
        IDbConnection connection = null;
        string connectionString = "Data Source = " + this.dataSource + "; " +
                                  "Database = " + this.dataBase + "; " +
                                  "Integrated Security = false; " +
                                  "User ID = " + this.userId + "; " +
                                  "Password = " + this.password;
        try {
            connection = new System.Data.SqlClient.SqlConnection(connectionString);
            connection.Open();
        } catch (System.Data.SqlClient.SqlException sqle) {
            Close(connection);
            throw new DAOException("GetConnection: " + sqle);
        } 
        return connection;
    }

    public void Close(IDbConnection connection) {
        try {
            if (connection != null) {
                connection.Close();
            }
        } catch (System.Data.SqlClient.SqlException sqle) {
            System.Console.WriteLine(sqle);
        }
    }

    public void Close(IDataReader dataReader) {
        try {
            if (dataReader != null) {
                dataReader.Close();
            }
        } catch (System.Data.SqlClient.SqlException sqle) {
            System.Console.WriteLine(sqle);
        }
    }

}
}
